import { Rule } from "./rules";
import { Maybe, StringTransformer } from "./utilities";
export declare type Lookaround = "native" | "group" | "none";
export declare const LOOKAROUND_DEFAULT = "group";
export declare type ProofreadingConfig = Readonly<{
    rules: ReadonlyArray<Rule>;
    markMistake: (info: Maybe<string>) => StringTransformer;
    markVerified: (info: Maybe<string>) => StringTransformer;
    lookaround?: Lookaround;
}>;
export declare function highlightWith(c: Readonly<{
    pattern: RegExp;
    mark: StringTransformer;
}>): StringTransformer;
export declare function proofreadWith(c: ProofreadingConfig): StringTransformer;
export declare function markMistakesAndVerifiedUsing(c: Readonly<{
    markMistake: (info: Maybe<string>) => StringTransformer;
    markVerified: (info: Maybe<string>) => StringTransformer;
    lookaround: Lookaround;
}>): (r: Rule) => StringTransformer;
export declare function markAll(kind: "mistakes" | "verified", mark: (info: Maybe<string>) => StringTransformer, lookaround: Lookaround): (r: Rule) => StringTransformer;
