import { Maybe } from "./utilities";
export declare const NO_INFO: null;
export declare type RuleCore = Readonly<{
    bad: string;
    good: string;
    info: Maybe<string>;
}>;
export declare type Rule = RuleCore & Readonly<{
    before: Maybe<RegExp>;
    match: RegExp;
    after: Maybe<RegExp>;
}>;
export declare function literalRule(core: RuleCore): (before: Maybe<string>, after: Maybe<string>) => Rule;
export declare function simpleRule(core: RuleCore): (before: Maybe<RegExp>, after: Maybe<RegExp>) => Rule;
export declare function matchRule(core: RuleCore): (before: Maybe<RegExp>, match: RegExp, after: Maybe<RegExp>) => Rule;
export declare function regexRule(core: RuleCore): (regex: RegExp) => Rule;
