"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const escape_string_regexp_1 = __importDefault(require("escape-string-regexp"));
const utilities_1 = require("./utilities");
exports.NO_INFO = null;
function literalRule(core) {
    const literal = utilities_1.fmap(literalRegex);
    return (before, after) => simpleRule(core)(literal(before), literal(after));
}
exports.literalRule = literalRule;
function simpleRule(core) {
    return (before, after) => matchRule(core)(before, literalRegex(core.bad), after);
}
exports.simpleRule = simpleRule;
function matchRule(core) {
    return (before, match, after) => (Object.assign({ before,
        match,
        after }, core));
}
exports.matchRule = matchRule;
function regexRule(core) {
    return regex => (Object.assign({ before: null, match: regex, after: null }, core));
}
exports.regexRule = regexRule;
function literalRegex(s) {
    return new RegExp(escape_string_regexp_1.default(s));
}
//# sourceMappingURL=rules.js.map