import escapeRegex from "escape-string-regexp";
import { fmap, } from "./utilities";
export const NO_INFO = null;
export function literalRule(core) {
    const literal = fmap(literalRegex);
    return (before, after) => simpleRule(core)(literal(before), literal(after));
}
export function simpleRule(core) {
    return (before, after) => matchRule(core)(before, literalRegex(core.bad), after);
}
export function matchRule(core) {
    return (before, match, after) => (Object.assign({ before,
        match,
        after }, core));
}
export function regexRule(core) {
    return regex => (Object.assign({ before: null, match: regex, after: null }, core));
}
function literalRegex(s) {
    return new RegExp(escapeRegex(s));
}
//# sourceMappingURL=rules.js.map